Option Explicit On
Imports PClient = Intergraph.GeoMedia.PClient
Imports PBasic = Intergraph.GeoMedia.PBasic
Imports PPipe = Intergraph.GeoMedia.PPipe
Imports PView = Intergraph.GeoMedia.PView
Imports GDO = Intergraph.GeoMedia.GDO
Imports Windows = Intergraph.GeoMedia.GeoMedia.Windows
Imports PDBPipe = Intergraph.GeoMedia.PDBPipe
Imports GMMapView = Intergraph.GeoMedia.MapviewLib.GMMapView
Imports PCSS = Intergraph.GeoMedia.PCSS
Imports VB = Microsoft.VisualBasic
Public Class frmAddGraphics
    Dim objwnds As Windows = Nothing
    Dim GMMapView As New GMMapView
    Dim objDB As GDO.GDatabase

    Private Sub frmAddGraphics_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'Find MapWindow
        Dim I As Integer
        objwnds = gobjGeoApp.Windows
        For I = 1 To objwnds.Count
            If objwnds.Item(I).Type = "MapWindow" Then
                'Connect to active MapWindow
                GMMapView = objwnds.Item(I).MapView
            End If
        Next

        'Find Database
        objDB = gobjGeoApp.Document.Connections(1).Database

        'Find legend
        Dim objLegend As PView.Legend
        objLegend = GMMapView.Legend

        'Find legend entries and put it on cbx_entitatsGrafiques
        Dim objLEentry As PView.LegendEntry
        'Clear the combo before adding new items
        Me.cbx_entitatsGrafiques.Items.Clear()
        For Each objLEentry In objLegend.LegendEntries
            Me.cbx_entitatsGrafiques.Items.Add(objLEentry.Name)
        Next

        'Select the first element
        Me.cbx_entitatsGrafiques.SelectedIndex = 0
        'Clear the listbox lbx_entitatsGrafiquesCamps
        Me.lbx_entitatsGrafiquesCamps.ClearSelected()

        'Find data tables and put it on cbx_TaulaDades
        Dim objRS As GDO.GRecordset
        'Clear the combo before adding new items
        Me.cbx_taulaDades.Items.Clear()
        'GFeatures contains all non structural tables on database. 
        objRS = objDB.OpenRecordset("GFeatures", GDO.GConstants.gdbOpenDynaset)
        'Non spatial tables has -1 on GeometryType field
        Do While Not objRS.EOF
            If objRS.GFields("GeometryType").Value = -1 Then
                Me.cbx_taulaDades.Items.Add(objRS.GFields("FeatureName").Value)
            End If
            objRS.MoveNext()
        Loop

        'Select the first element
        Me.cbx_taulaDades.SelectedIndex = 0
        'Clear the lbx_taulaDadesCamps listbox
        Me.lbx_taulaDadesCamps.ClearSelected()
        'Clear the lbx_dadesGrafics
        Me.lbx_dadesGrafic.ClearSelected()


        'Select the first kind of graphic
        Me.rbt_barres.Select()

    End Sub

    Private Sub btn_cancelar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_cancelar.Click
        'Close the form
        Close()
    End Sub

    Private Sub cbx_taulaDades_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles cbx_taulaDades.SelectedIndexChanged
        Dim objFld As GDO.GField

        'Clear the lbx_taulaDadesCamps listbox
        Me.lbx_taulaDadesCamps.Items.Clear()

        'Clear the lbx_dadesGrafics
        Me.lbx_dadesGrafic.Items.Clear()

        'Fill in list of fields for lbx_taulaDadesCamps
        For Each objFld In objDB.OpenRecordset(Me.cbx_taulaDades.SelectedItem.ToString).GFields
            Me.lbx_taulaDadesCamps.Items.Add(objFld.Name)
        Next

    End Sub

    Private Sub cbx_entitatsGrafiques_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles cbx_entitatsGrafiques.SelectedIndexChanged
        Dim objFld As GDO.GField

        'Clear the listbox
        Me.lbx_entitatsGrafiquesCamps.Items.Clear()

        'Fill in list of fields for lbx_entitatsGrafiquesCamps
        For Each objFld In objDB.OpenRecordset(Me.cbx_entitatsGrafiques.SelectedItem.ToString, GDO.GConstants.gdbOpenDynaset).GFields
            Me.lbx_entitatsGrafiquesCamps.Items.Add(objFld.Name)
        Next

    End Sub


    Private Sub lbx_taulaDadesCamps_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles lbx_taulaDadesCamps.SelectedIndexChanged
        Dim objFld As GDO.GField

        'Clear the lbx_dadesGrafic listbox
        Me.lbx_dadesGrafic.Items.Clear()

        'Fill in list of fields for lbx_taulaDadesCamps
        For Each objFld In objDB.OpenRecordset(Me.cbx_taulaDades.SelectedItem.ToString).GFields
            Me.lbx_dadesGrafic.Items.Add(objFld.Name)
        Next

        'Remove selected field from lbx_taulaDadesCamps
        Me.lbx_dadesGrafic.Items.Remove(Me.lbx_taulaDadesCamps.SelectedItem)

    End Sub

    Private Sub btn_insertar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_insertar.Click
        'Get table names
        Dim strDataTableName As String = ""
        Dim strGraphicTableName As String = ""
        strDataTableName = Me.cbx_taulaDades.SelectedItem.ToString
        strGraphicTableName = Me.cbx_entitatsGrafiques.SelectedItem.ToString

        'Get data table realte field
        Dim strDataTableRelFld As String = ""
        If Me.lbx_taulaDadesCamps.SelectedItems.Count < 1 Then
            MsgBox("No s'ha seleccionat el camp de relaci de la taula de dades", MsgBoxStyle.Exclamation)
            Exit Sub
        Else
            strDataTableRelFld = Me.lbx_taulaDadesCamps.SelectedItem.ToString
        End If

        'Get graphic table relate field
        Dim strGraphicTableRelFld As String = ""
        If Me.lbx_entitatsGrafiquesCamps.SelectedItems.Count < 1 Then
            MsgBox("No s'ha seleccionat el camp de relaci de la taula d'entitats grfiques", MsgBoxStyle.Exclamation)
            Exit Sub
        Else
            strGraphicTableRelFld = Me.lbx_entitatsGrafiquesCamps.SelectedItem.ToString
        End If

        'Get selected data fields. Check for at least one selected field
        If Me.lbx_dadesGrafic.SelectedItems.Count < 1 Then
            MsgBox("No hi ha camps de dades seleccionats", MsgBoxStyle.Exclamation)
            Exit Sub
        End If

        'Create a recordset with the geometric field and the statistic fields
        Dim a As Integer
        Dim strQry As String = ""

        'inicialize the query and get geometry field
        strQry = "Select " & strGraphicTableName & ".Geometry, "

        'Get field names for the query
        For a = 0 To Me.lbx_dadesGrafic.SelectedItems.Count - 1
            strQry = strQry & strDataTableName & "." & Me.lbx_dadesGrafic.SelectedItems.Item(a).ToString & ", "
        Next a

        'Trim last comma
        strQry = VB.Left(strQry, Len(strQry) - 2)

        'Add FROM clause and statistic table name
        strQry = strQry & " from " & strDataTableName

        'Add INNER JOIN clause
        strQry = strQry & " INNER JOIN " & strGraphicTableName & " ON " & strDataTableName & "." & strDataTableRelFld & " = " & _
                 strGraphicTableName & "." & strGraphicTableRelFld

        'Construct the recordset with the query
        Dim objRS As GDO.GRecordset
        Dim objFlds() As Object
        objRS = objDB.OpenRecordset(strQry)

        If objRS.RecordCount = 0 Then
            MsgBox("No es poden relacionar les dades amb les entitats grfiques", MsgBoxStyle.Exclamation)
            Me.Close()
            Exit Sub
        End If

        'Redimension objFields for the number of data fields. We hava a geom field
        ReDim objFlds(objRS.GFields.Count - 2)

        'Get the center of geometryc elements. Create a CenterPointPipe. The output recordset has the same fields that imput plus a
        'geometric field for the centers
        Dim objCPoint As New PPipe.CenterPointPipe
        'Set Center Point parameters
        With objCPoint
            .InputRecordset = objRS
            .InputGeometryFieldName = "Geometry"
            .OutputGeometryFieldName = "CenterPGeometry"
        End With
        'Save the new recordset
        Dim objOutputRS As GDO.GRecordset
        objOutputRS = objCPoint.OutputRecordset

        'Create a customDataPipe and a new field for graphic data representation
        Dim objCDP As PDBPipe.CustomDataPipe
        objCDP = CreateObject("GeoMedia.CustomDataPipe")
        'Get MapView coord System
        Dim objCS As PCSS.CoordSystem
        objCS = GMMapView.CoordSystemsMgr.CoordSystem
        'Add new field
        Dim gfdField As GDO.GField
        gfdField = objCDP.CreateField
        With gfdField
            .Name = "Geometry"
            .Type = GDO.GConstants.gdbSpatial
            .CoordSystemGUID = objCS.GUID
            .SubType = GDO.GConstants.gdbAnySpatial
        End With
        objCDP.GFields.Append(gfdField)
        'Get Recordset from CDP
        Dim objCDPRecordset As GDO.GRecordset
        objCDPRecordset = objCDP.OutputRecordset

        Dim myRow As Object
        Dim I As Integer
        Dim GSS As PClient.GeometryStorageService
        GSS = CreateObject("Geomedia.GeometryStorageService")
        Do While objOutputRS.EOF <> True
            On Error Resume Next
            myRow = objOutputRS.GetRows(1)
            'I identifies the field and 0 the row. Discard first field for graphic.
            For I = 1 To objOutputRS.GFields.Count - 2
                objFlds(I - 1) = myRow(I, 0)
            Next I
            'Get centerPoint geometry field.Is the last one. Need StorageToGeometry
            Dim objPoint As New PBasic.PointGeometry
            GSS.StorageToGeometry(myRow(objOutputRS.GFields.Count - 1, 0), objPoint)
            'Generate CompositePolygonGeometry pass objFlds
            If objPoint.Origin.X = 0.0 Then Resume Next
            'If bar char is selected contruct polygon geometries
            If Me.rbt_barres.Checked = True Then
                Dim CPolyGeom As PBasic.CompositePolygonGeometry
                CPolyGeom = objCPolyGeom(objPoint.Origin.X, objPoint.Origin.Y, objPoint.Origin.Z, Me.tbr_separacioDades.Value, objFlds)
                With objCDPRecordset
                    .AddNew()
                    GSS.SetGeometry(.GFields("Geometry"), CPolyGeom)
                    .Update()
                End With
            ElseIf Me.rbt_linies.Checked = True Then
                Dim CPlineGeom As PBasic.CompositePolylineGeometry
                CPlineGeom = objCPlineGeom(objPoint.Origin.X, objPoint.Origin.Y, objPoint.Origin.Z, Me.tbr_separacioDades.Value, objFlds)
                With objCDPRecordset
                    .AddNew()
                    GSS.SetGeometry(.GFields("Geometry"), CPlineGeom)
                    .Update()
                End With
            End If
        Loop

        'Place graphic geometry into Map View
        Dim objLE As New PView.LegendEntry
        'Create and display
        objLE = CreateObject("GeoMedia.LegendEntry")

        'Specify title for new layer
        Dim objpropertyT As New PDBPipe.GMProperty
        objpropertyT.Name = "Title"
        objpropertyT.Value = strDataTableName

        'Set legend entry characteristics
        With objLE
            .GeometryFieldName = "Geometry"
            .InputRecordset = objCDPRecordset
            If Me.rbt_barres.Checked = True Then
                .Style = createAreaStyle(Me.tbr_LineWidth.Value, RGB(0, 0, 100), RGB(0, 150, 200))
            ElseIf Me.rbt_linies.Checked = True Then
                .Style = createLineStyle(Me.tbr_LineWidth.Value, RGB(0, 0, 100))
            End If
            .PropertySet.Append(objpropertyT)
        End With

        'Set title font
        GMMapView.Legend.DefaultTitleFont = createObjFont("Arial", 10, True)
        GMMapView.Legend.DefaultTitleFontColor = RGB(0, 0, 100)

        GMMapView.Legend.LegendEntries.Append(objLE, 1)
        objLE.LoadData()

        GMMapView.Fit()
        GMMapView.Refresh()

        'Close the form
        Me.Close()

    End Sub
    Private Function objCPolyGeom(ByVal x As Double, ByVal y As Double, ByVal z As Double, ByVal width As Double, ByVal objHeigthValues() As Object) As PBasic.CompositePolygonGeometry
        Dim objYvalue As Object
        Dim height As Double
        objCPolyGeom = CreateObject("Geomedia.CompositePolygonGeometry")

        For Each objYvalue In objHeigthValues
            height = CDbl(objYvalue) / Me.tbr_Alsada.Value.ToString
            'Create a polygon 
            objCPolyGeom.Add(objPolyGeom(x, y, z, Width, height))
            'Move the origin for next bar
            x = x + Width
        Next

        Return objCPolyGeom
    End Function
    Public Function objPolyGeom(ByVal xOrigin As Double, ByVal yOrigin As Double, ByVal zOrigin As Double, _
    ByVal width As Double, ByVal height As Double) As PBasic.PolygonGeometry
        Dim n As Integer
        Dim objPoint(0 To 4) As PBasic.point

        objPolyGeom = New PBasic.PolygonGeometry

        For n = 0 To 4
            objPoint(n) = CreateObject("GeoMedia.Point")
        Next n

        'Create first polygon 
        objPoint(0).X = xOrigin
        objPoint(0).Y = yOrigin
        objPoint(0).Z = zOrigin
        objPoint(1).X = xOrigin + width
        objPoint(1).Y = yOrigin
        objPoint(1).Z = zOrigin
        objPoint(2).X = xOrigin + width
        objPoint(2).Y = yOrigin + height
        objPoint(2).Z = zOrigin
        objPoint(3).X = xOrigin
        objPoint(3).Y = yOrigin + height
        objPoint(3).Z = zOrigin
        objPoint(4).X = xOrigin
        objPoint(4).Y = yOrigin
        objPoint(4).Z = zOrigin

        For n = 0 To 4
            objPolyGeom.Points.Add(objPoint(n))
        Next n
        Return objPolyGeom
    End Function
    Private Function objCPlineGeom(ByVal x As Double, ByVal y As Double, ByVal z As Double, ByVal width As Double, ByVal objHeigthValues() As Object) As PBasic.CompositePolylineGeometry
        Dim objYvalue As Object
        Dim height As Double, height1 As Double
        objCPlineGeom = CreateObject("Geomedia.CompositePolylineGeometry")
        height1 = 0.0

        For Each objYvalue In objHeigthValues
            height = (CDbl(objYvalue) / Me.tbr_Alsada.Value.ToString)
            'Create a polygon 
            objCPlineGeom.Add(objPlineGeom(x, y, z, width, height - height1))
            'move the origin for next line
            x = x + width
            y = y + height - height1
            height1 = height
        Next
        Return objCPlineGeom
    End Function
    Public Function objPlineGeom(ByVal xOrigin As Double, ByVal yOrigin As Double, ByVal zOrigin As Double, _
ByVal width As Double, ByVal height As Double) As PBasic.PolylineGeometry
        Dim n As Integer
        Dim objPoint(0 To 1) As PBasic.point

        objPlineGeom = New PBasic.PolylineGeometry

        For n = 0 To 1
            objPoint(n) = CreateObject("GeoMedia.Point")
        Next n

        'Create first polygon 
        objPoint(0).X = xOrigin
        objPoint(0).Y = yOrigin
        objPoint(0).Z = zOrigin
        objPoint(1).X = xOrigin + width
        objPoint(1).Y = yOrigin + height
        objPoint(1).Z = zOrigin

        For n = 0 To 1
            objPlineGeom.Points.Add(objPoint(n))
        Next n
        Return objPlineGeom
    End Function
    Private Function createObjFont(ByVal fontName As String, ByVal fontSize As Integer, ByVal fontBold As Boolean) As stdole.StdFont
        createObjFont = CreateObject("StdFont")
        With createObjFont
            .Name = fontName
            .Size = fontSize
            .Bold = fontBold
        End With

    End Function
    Private Function createAreaStyle(ByVal boundaryWidth As Integer, ByVal boundaryRGBColor As Object, ByVal fillRGBColor As Object) As PView.StyleDefinition
        Dim objstyleService As New PView.StyleService
        Dim geomStyle As New PView.StyleDefinition

        objstyleService.GetStyle("Area Style", geomStyle)

        'Specify boundary style
        Dim objstyleB As PView.StyleDefinition
        objstyleB = geomStyle.StyleDefinitions(0).StyleDefinitions(0)
        objstyleB.StyleProperties(PView.StylePropertyConstants.gmgroPropertyWidth).Value = boundaryWidth
        objstyleB.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = boundaryRGBColor

        'Specify fill color
        Dim objstyleF As PView.StyleDefinition
        objstyleF = geomStyle.StyleDefinitions(1).StyleDefinitions(0)
        objstyleF.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = fillRGBColor
        createAreaStyle = geomStyle

    End Function
    Private Function createLineStyle(ByVal lineWidth As Integer, ByVal lineRGBColor As Object) As PView.StyleDefinition
        Dim objstyleService As New PView.StyleService
        Dim geomStyle As New PView.StyleDefinition

        objstyleService.GetStyle("Simple Line Style", geomStyle)

        'Specify boundary style
        geomStyle.StyleProperties(PView.StylePropertyConstants.gmgroPropertyWidth).Value = lineWidth
        geomStyle.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = lineRGBColor

        createLineStyle = geomStyle

    End Function

End Class









































